unit GZipFuncs;

interface

uses GPAZLib, classes;

//  function CompressStreamToStream(FSource: TMemoryStream; Size: LongInt; var FDest: TMemoryStream): LongInt;
  function DecompressStreamToStream(FSource: TMemoryStream; Size, RealSize: LongInt; var FDest: TMemoryStream): LongInt;

const
//  GZip_BufferSize=5000000;
  GZBufferSize=50000;
  crNone=0;
  crFastest=1;
  crDefault=2;
  crMax=3;

var
//  GZip_Buffer: array[1..GZip_BufferSize]of byte;
  GZBuffer: array[1..GZBufferSize]of byte;

implementation

{function CompressStreamToStream(FSource: TMemoryStream; Size: LongInt; var FDest: TMemoryStream): LongInt;
var
  CIn: TCompressionStream;
  O1,O2: LongInt;
begin
  FSource.Read(GZip_Buffer,Size);
  O1:=FDest.Position;
  CIn:=TCompressionStream.Create(clMax,FDest);
  CIn.Write(GZip_Buffer,Size);
  CIn.Free;
  O2:=FDest.Position;
  CompressStreamToStream:=O2-O1;
end;}

function DecompressStreamToStream(FSource: TMemoryStream; Size, RealSize: LongInt; var FDest: TMemoryStream): LongInt;
var
  COut: TDecompressionStream;
  i,TotalBlocks: LongInt;
begin
  COut:=TDecompressionStream.Create(FSource);
  TotalBlocks:=RealSize div GZBufferSize;
  if TotalBlocks=0 then
  begin
    COut.Read(GZBuffer,RealSize);
    FDest.Write(GZBuffer,RealSize);
  end else
  begin
    for i:=1 to TotalBlocks do
    begin
      COut.Read(GZBuffer,GZBufferSize);
      FDest.Write(GZBuffer,GZBufferSize);
    end;
    if RealSize-TotalBlocks*GZBufferSize>0 then
    begin
      COut.Read(GZBuffer,RealSize-TotalBlocks*GZBufferSize);
      FDest.Write(GZBuffer,RealSize-TotalBlocks*GZBufferSize);
    end;
  end;
  COut.Free;
end;

begin
end.
