program QuickIG2DAT;
{$APPTYPE CONSOLE}
uses
  Windows,SysUtils,classes,GZipFuncs;

const
  dmHelp=0;
  dmNoExtractingMask=1;

var
  t: Integer;
  FDat: TFileStream;
  FIn,FOut: TMemoryStream;
  sr: TSearchRec;
  i: Integer;
  c: char;
  SavePosition: LongInt;
  DATDirectory,CurDir,P1,P2: string;
  DATHeader: record
               Files: LongInt; // 
               FAT: LongInt; //  FAT   
             End;
  Entries: array of record
                      Name: string;
                      Offset: LongInt; //  
                      Junk_1: LongInt; //
                      Size: LongInt; // 
                      RealSize: LongInt; // 
                      Junk_2: array[1..4]of char; //
                    end;
{    }
function UpCaseStr(s: string): string;
var
  i: Byte;
  t: string;
begin
  t:='';
  if Length(s)>0 then for i:=1 to Length(s) do t:=t+UpCase(s[i]);
  UpCaseStr:=t;
end;
{ }
procedure DoMessage(dm: byte);
begin
  case dm of
  dmHelp:begin
           WriteLn;
           WriteLn('Quick Imperium Galactica 2 DAT converter. v1.3   3 october 2001');
           WriteLn('Usage: QuickIG2DAT.exe <command> <#.dat>');
           WriteLn('Commands:');
           WriteLn(' -h : This help');
           WriteLn(' -l : Get files list (name,position,size)');
           WriteLn(' -x : Extract files');
           WriteLn('  # : Mask for DAT archives');
           WriteLn;
           WriteLn('Example: quickig2dat.exe -x *.dat');
           WriteLn('         Extracts files from all dat archives in the current folder');
           WriteLn;
           WriteLn('Author: Michail Beschetnov');
           WriteLn('E-mail: collapse_forever@mail.ru');
           WriteLn('Web:    http://termius.narod.ru');
         end;
  dmNoExtractingMask:begin
                       WriteLn;
                       WriteLn('Extracting files.');
                       WriteLn('Error: No DAT files specified!');
                     end;
  end;
end;
{  }
function DirExists(const Name: string): Boolean;
var
  Code: Integer;
begin
  Code := GetFileAttributes(PChar(Name));
  Result := (Code <> -1) and (FILE_ATTRIBUTE_DIRECTORY and Code <> 0);
end;
{  }
function MakeTree(Dir: string): Boolean;
begin
  Result := True;
  if Length(Dir) = 0 then Exit;
  Dir := ExcludeTrailingBackslash(Dir);
  if (Length(Dir) < 3) or DirExists(Dir) or (ExtractFilePath(Dir) = Dir) then Exit; // avoid 'xyz:\' problem.
  Result := MakeTree(ExtractFilePath(Dir)) and CreateDir(Dir);
end;

function ExtractDat(FName: string): string;
begin
  WriteLn('*** Archive '+FName+' loaded');
  FDat:=TFileStream.Create(FName,fmOpenRead);
  FDat.Seek(FDat.Size-8,soFromBeginning);
  FDat.Read(DatHeader,8);
  FDat.Seek(FDat.Size-DATHeader.FAT,soFromBeginning);
  SetLength(Entries,DatHeader.Files);
  for i:=1 to DatHeader.Files do
  begin
    Entries[i-1].Name:='';
    repeat
      FDat.Read(c,1);
      if not(c=#$00)then Entries[i-1].Name:=Entries[i-1].Name+c;
    until c=#$00;
    FDat.Read(Entries[i-1].Offset,4);
    FDat.Read(Entries[i-1].Junk_1,4);
    FDat.Read(Entries[i-1].Size,4);
    FDat.Read(Entries[i-1].RealSize,4);
    FDat.Read(Entries[i-1].Junk_2,4);
  end;
  DATDirectory:='';
  repeat
    FDat.Read(c,1);
    if not(c=#$00)then DATDirectory:=DATDirectory+c;
  until c=#$00;
  {*** }
  MakeTree(DATDirectory);
  for i:=1 to DatHeader.Files do
  begin
    Write(DATDirectory+'\'+ExtractFileName(Entries[i-1].Name)+' ... ');
    FOut:=TMemoryStream.Create;
    FDAT.Seek(Entries[i-1].Offset,soFromBeginning);
    if Entries[i-1].Junk_1=0 then FOut.CopyFrom(FDAT,Entries[i-1].Size) else
    begin
      FIn:=TMemoryStream.Create;
      FIn.CopyFrom(FDAT,Entries[i-1].Size);
      FIn.Seek(0,soFromBeginning);
      DecompressStreamToStream(FIn,Entries[i-1].Size,Entries[i-1].RealSize,FOut);
      FIn.Free;
    end;
    FOut.SaveToFile(DATDirectory+'\'+Entries[i-1].Name);
    FOut.Free;
    WriteLn('done');
  end;
  {*** }
  WriteLn('*** Archive '+FName+' closed');
  FDat.Free;
end;

procedure DoDAT;
begin
  if FindFirst(P2, faAnyFile-faDirectory, sr) = 0 then
  begin
    ExtractDAT(sr.name);
    while FindNext(sr) = 0 do ExtractDAT(sr.name);
    FindClose(sr);
  end;
end;

begin
  GetDir(0,CurDir);
  P1:=UpCaseStr(ParamStr(1));
  P2:=UpCaseStr(ParamStr(2));
  if Length(P1)=0 then
  begin
    DoMessage(dmHelp);
    Exit;
  end;
  if P1='-H' then
  begin
    DoMessage(dmHelp);
    Exit;
  end;
  if P1='-X' then
  if Length(P2)=0 then
  begin
    DoMessage(dmNoExtractingMask);
    Exit;
  end else DoDAT;
end.